//
//  ExternalLinkParameters.h
//  ZillowMap
//
//  Created by Curtis Yamanaka on 10/4/2011.
//  Copyright 2011 Zillow, Inc. All rights reserved.
//

// External link constant strings
#define EXTERNAL_LINK_BASE_URL  @"baseURL"
#define EXTERNAL_LINK_SEARCH    @"searchTerm"
#define EXTERNAL_LINK_DISPLAY   @"display"

//Base Search URLs
#define EXTERNAL_LINK_BASE_FS @"for_sale"
#define EXTERNAL_LINK_BASE_FR @"for_rent"
#define EXTERNAL_LINK_BASE_MMM @"make_me_move"
#define EXTERNAL_LINK_BASE_RS @"recently_sold"
#define EXTERNAL_LINK_BASE_FSBO @"fsbo"
#define EXTERNAL_LINK_BASE_NEW @"new_homes"
#define EXTERNAL_LINK_BASE_POPULAR @"most_popular"
#define EXTERNAL_LINK_BASE_COMP @"comps" 
#define EXTERNAL_LINK_BASE_COMP_FS @"comps_for_sale"
#define EXTERNAL_LINK_BASE_COMP_FR @"comps_for_rent"

//Filter parameters
#define EXTERNAL_LINK_FILTER_BATHS @"baths"
#define EXTERNAL_LINK_FILTER_BEDS @"beds"
#define EXTERNAL_LINK_FILTER_DAYS @"days"
#define EXTERNAL_LINK_FILTER_TYPE @"type"
#define EXTERNAL_LINK_FILTER_LISTING @"lt"
#define EXTERNAL_LINK_FILTER_LOT @"lot"
#define EXTERNAL_LINK_FILTER_PRICE @"price"
#define EXTERNAL_LINK_FILTER_PAYMENT @"mp"
#define EXTERNAL_LINK_FILTER_SALE @"fs"
#define EXTERNAL_LINK_FILTER_RENT @"fr"
#define EXTERNAL_LINK_FILTER_MMM @"mmm"
#define EXTERNAL_LINK_FILTER_SOLD @"rs"
#define EXTERNAL_LINK_FILTER_ALL @"ah"
#define EXTERNAL_LINK_FILTER_SIZE @"size"
#define EXTERNAL_LINK_FILTER_BUILT @"built"
#define EXTERNAL_LINK_FILTER_PHOTOS @"photos"
#define EXTERNAL_LINK_FILTER_OPEN_HOUSES @"open"
#define EXTERNAL_LINK_FILTER_PRICE_REDUCTIONS @"red"
#define EXTERNAL_LINK_FILTER_SPECIAL_OFFERS @"zso"

//Location Types
#define EXTERNAL_LINK_LOCATION_RIGHTBOX @"rb"
#define EXTERNAL_LINK_LOCATION_MAP_RECT @"rect"
#define EXTERNAL_LINK_LOCATION_RID @"rid"
#define EXTERNAL_LINK_LOCATION_SSID @"ssid"
#define EXTERNAL_LINK_LOCATION_ZOOM @"zm"
#define EXTERNAL_LINK_LOCATION_ZPID @"zpid"

//Display Mode Types
#define EXTERNAL_LINK_DISPLAY_MAP @"map"
#define EXTERNAL_LINK_DISPLAY_STREET @"steet"
#define EXTERNAL_LINK_DISPLAY_AERIAL @"aerial"
#define EXTERNAL_LINK_DISPLAY_HYBRID @"hybrid"
#define EXTERNAL_LINK_DISPLAY_LIST @"list"
#define EXTERNAL_LINK_DISPLAY_MATCHING @"building"
#define EXTERNAL_LINK_DISPLAY_ALL @"allunits"
#define EXTERNAL_LINK_DISPLAY_COMP @"comps"

//Home Types
#define EXTERNAL_LINK_HOME_SINGLE @"house"
#define EXTERNAL_LINK_HOME_CONDO @"apartment_condo"
#define EXTERNAL_LINK_HOME_MULTI @"duplex"
#define EXTERNAL_LINK_HOME_MANUFACTURED @"mobile"
#define EXTERNAL_LINK_HOME_LAND @"land"

//Listing Types
#define EXTERNAL_LINK_LISTING_ALL @"all"
#define EXTERNAL_LINK_LISTING_FSBA @"fsba"
#define EXTERNAL_LINK_LISTING_FSBO @"fsbo"
#define EXTERNAL_LINK_LISTING_FORECLOSURE @"fore"
#define EXTERNAL_LINK_LISTING_NEW @"new"


@interface ExternalLinkParameters : NSObject
{
    NSArray *baseURLs_;
    NSArray *filterParamType_;
    NSArray *searchURLDisplayModeType_;
}

- (NSMutableDictionary *)parseParameters:(NSString *)queryString;
- (void)updateFilterFilterModel:(id<ZFilterModelTraits>)filterModel;
- (id)initWithQueryString:(NSString *)queryString;
@property (nonatomic, strong, readonly) NSMutableDictionary *parsedParameters;
@end
